%%%%%%%%%%%   LUC ABM Genetic Algorithm Parameter Searh   %%%%%%%%%%%%%%
% Random number seed
stream=RandStream.create('mrg32k3a','Seed',13);
RandStream.setGlobalStream(stream);
stream.Substream=3;
repeatstate1=stream.State;
stream.Substream=1;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
global PARMS POP GEN parmset fitness outcomeset evalset fitset pset g p 


PARMS=4;
POP=20;
GEN=3;
parmset=zeros(POP,PARMS,GEN);
% parmset = [nfwageparm farmcostparm nfarmcostparm croppriceparm]
fitness=zeros(POP,2,GEN);   %[fitness_score id]
outcomeset=zeros(POP,5,GEN);
evalset=zeros(POP,3,GEN);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Parameter set
parmset(:,1,1)=2.5*rand(POP,1);
parmset(:,2,1)=0.1+(0.8-0.1)*rand(POP,1);
parmset(:,3,1)=0.1+(0.8-0.1)*rand(POP,1);
parmset(:,4,1)=2.5*rand(POP,1);

pset=(1:PARMS);

genset=zeros([],1);
finalset=zeros([],PARMS);
finalevalset=zeros([],PARMS-1);
finaloutset=zeros([],PARMS+1);

for g=1:GEN
    for p=1:POP
        sprintf('p,g = %d,%d',p,g)
        
        LUC_ABM_15vparm_base_mi20_16
        
        evalset(p,:,g)=[surpluscheck cvconsumecheck asplevelcheck];
        outcomeset(p,:,g)=[avgcultfreq surplus_ind cvconsume_ind asplevel_ind mktprod_ind];
    end
    
    fitness(:,:,g)=[sum(evalset(:,:,g),2) (1:POP)'];
    sortfit=sortrows(fitness(:,:,g),-1);
    fitcut=ceil(POP*0.25);

    fitset=(1:fitcut);
    bestset=parmset(sortfit(1:fitcut,2),:,g);

    % crossover
    crsspt=ceil((PARMS-1)*rand(fitcut,1));
    pairs=round(1+(fitcut-1)*rand(fitcut,2));
    
    %mutant
    mutes=ceil((PARMS-2)*rand(10,1));

    for i=1:5
        
        if pairs(i,1) == pairs(i,2)
            altset=find(fitset ~= pairs(i,2));
            randpick=ceil(length(altset)*rand(1));
            pairs(i,2)=fitset(altset(randpick));
        end
        parmset(i,:,g+1)=[bestset(pairs(i,1),1:crsspt(i)) ...
            bestset(pairs(i,2),crsspt(i)+1:PARMS)];
    end
        
%     for i=1:length(mutes)
    for i=1:5
        mutpts=ceil(PARMS*rand(1,mutes(i)));
        mutset=round(1+(length(bestset(:,1))-1)*rand(1,mutes(i)));
        mutant=bestset(ceil(length(bestset(:,1))*rand(1)),:);
        for im=1:mutes(i)
            mutant(mutpts(im))=bestset(mutset(im),mutpts(im));
        end
        parmset(i+fitcut,:,g+1)=mutant;
    end
 
    % New, random generation
    parmset(POP-4:POP,1,g+1)=2.5*rand(10,1);
    parmset(POP-4:POP,2,g+1)=0.1+(0.7-0.1)*rand(10,1);
    parmset(POP-4:POP,3,g+1)=0.1+(0.8-0.1)*rand(10,1);
    parmset(POP-4:POP,4,g+1)=2.5*rand(10,1);

    parmset(:,:,g+1)=[max(min(parmset(:,1,g+1),2.5),0) ...
        max(min(parmset(:,2,g+1),0.8),0.1) ...
        max(min(parmset(:,3,g+1),0.8),0.1) ...
        max(min(parmset(:,4,g+1),2.5),0)];
    
    ikeep=find(fitness(:,1,g) == max(fitness(:,1,g)));
    genset(length(genset)+1:length(genset)+length(ikeep),1)=g;
    finalset(length(finalset)+1:length(finalset)+length(ikeep),:)=parmset(ikeep,:,g);
    finalevalset(length(finalevalset)+1:length(finalevalset)+length(ikeep),:)=evalset(ikeep,:,g);
    finaloutset(length(finaloutset)+1:length(finaloutset)+length(ikeep),:)=outcomeset(ikeep,:,g);
end

%%%%%%%%%%%%%%%%%%%%

poplabel={'POPDEN'};
mktinflabel={'MKTINF'};
evallabel={'Eval Set'};
outcomelabel={'Outcome Set'};
finallabel={'Final Parm Set'};
genlabel={'Gen'};

save parmset_17v0_GenAlgo_mi20_16 parmset outcomeset evalset finalset genset finalevalset finaloutset

resultsfile=('Results_LUC_ABM_17v0_GenAlgo_mi20_16.xlsx');
xlswrite(resultsfile,poplabel,sprintf('pop%g_mi%g',POPDEN,MKTINF),'A1');
xlswrite(resultsfile,POPDEN,sprintf('pop%g_mi%g',POPDEN,MKTINF),'B1');
xlswrite(resultsfile,mktinflabel,sprintf('pop%g_mi%g',POPDEN,MKTINF),'A2');
xlswrite(resultsfile,MKTINF,sprintf('pop%g_mi%g',POPDEN,MKTINF),'B2');
xlswrite(resultsfile,genlabel,sprintf('pop%g_mi%g',POPDEN,MKTINF),'A4');
xlswrite(resultsfile,genset,sprintf('pop%g_mi%g',POPDEN,MKTINF),'A5');
xlswrite(resultsfile,evallabel,sprintf('pop%g_mi%g',POPDEN,MKTINF),'B4');
xlswrite(resultsfile,finalevalset,sprintf('pop%g_mi%g',POPDEN,MKTINF),'B5');
xlswrite(resultsfile,outcomelabel,sprintf('pop%g_mi%g',POPDEN,MKTINF),'H4');
xlswrite(resultsfile,finaloutset,sprintf('pop%g_mi%g',POPDEN,MKTINF),'H5');
xlswrite(resultsfile,finallabel,sprintf('pop%g_mi%g',POPDEN,MKTINF),'N4');
xlswrite(resultsfile,finalset,sprintf('pop%g_mi%g',POPDEN,MKTINF),'N5');



